{{
Demo for the Maxim7219 object
Nick McClanahan - Released into Public domain
Rogersyd - Added the random code from realrandom and jkis32
Specifically written for oharap's blue LED matrix; http://www.gadgetgangster.com/282
Tested from RCFast to 80Mhz.  Probably also works at RC slow.
}}
CON
        _clkmode = xtal1 + pll16x                                               'Standard clock mode * crystal frequency = 80 MHz
        _xinfreq = 5_000_000
        R1 = 8            'Range is 0 to RANGE.
        S1 = 1            'Number of samples to pick: 1 to RANGE + 1
        R2 = 8
        S2 = 1
VAR

  long  seed
  byte  n1[R1 + 1]
  byte  n2[R2 + 1]


OBJ
LEDMatrix     : "maxim7219"
RandomNumb    : "RealRandom"
prng          : "jkiss32"

PUB start    | x, y

preprandom
LEDMatrix.init
waitcnt(clkfreq*2 + cnt)
LEDMatrix.clearscreen

repeat
  randots
  waitcnt(clkfreq /20 + cnt)

pub preprandom

  RandomNumb.start
  prng.start
  prng.seed (RandomNumb.random, RandomNumb.random, RandomNumb.random, RandomNumb.random, RandomNumb.random)   ' Seed the PRNG with real random numbers
  RandomNumb.stop

pub randots|r,c
 fill_array(r1,s1,1)
 fill_array(r2,s2,2)
 ledmatrix.drawpoint((n1-1),(n2-1))


PUB Fill_array(r,s,nums) | x, j

if nums == 1
  repeat x from 1 to r                              'Fill numbers array in order.
    n1[ x ] := x
  repeat x from 0 to s - 1
    j := (prng.random   >> 1) // (R - x + 1) + x
    s := n1[ j ]
    bytemove(@n1[ x + 1 ], @n1[ x ], j - x)       'Shift the values to make room.
    n1[ x ] := s                                'Put the selected number in the newly vacated spot.

if nums == 2
  repeat x from 1 to r                              'Fill numbers array in order.
    n2[ x ] := x
  repeat x from 0 to s - 1
    j := (prng.random   >> 1) // (R - x + 1) + x
    s := n2[ j ]
    bytemove(@n2[ x + 1 ], @n2[ x ], j - x)       'Shift the values to make room.
    n2[ x ] := s                                'Put the selected number in the newly vacated spot.


pub boxes
 repeat
   LEDMatrix.sendframe(@box1)
   waitcnt(clkfreq /2 + cnt)
   LEDMatrix.sendframe(@box2)
   waitcnt(clkfreq /2 + cnt)
   LEDMatrix.sendframe(@box3)
   waitcnt(clkfreq /2 + cnt)
   LEDMatrix.sendframe(@box4)
   waitcnt(clkfreq /2 + cnt)
   LEDMatrix.sendframe(@box3)
   waitcnt(clkfreq /2 + cnt)
   LEDMatrix.sendframe(@box2)
   waitcnt(clkfreq /2 + cnt)




pub stuff |x,y
  repeat x from 0 to 7
      repeat y from 0 to 7
         LEDMatrix.drawpoint(x,y)
         waitcnt(clkfreq /20 + cnt)



  LEDMatrix.sendframe(@frame2)
  waitcnt(clkfreq /2 + cnt)

DAT
        frame1          BYTE     %11100111
                        BYTE     %11100111
                        BYTE     %11100111
                        BYTE     %00000000
                        BYTE     %00000000
                        BYTE     %11100111
                        BYTE     %11100111
                        BYTE     %11100111

        frame2          BYTE     %00011000
                        BYTE     %00011000
                        BYTE     %00011000
                        BYTE     %11111111
                        BYTE     %11111111
                        BYTE     %00011000
                        BYTE     %00011000
                        BYTE     %00011000

        heart           BYTE     %00011000
                        BYTE     %00111100
                        BYTE     %01100110
                        BYTE     %11000011
                        BYTE     %11000011
                        BYTE     %01100110
                        BYTE     %00111100
                        BYTE     %00011000

        box1            BYTE     %11111111
                        BYTE     %10000001
                        BYTE     %10000001
                        BYTE     %10000001
                        BYTE     %10000001
                        BYTE     %10000001
                        BYTE     %10000001
                        BYTE     %11111111

        box2            BYTE     %00000000
                        BYTE     %01111110
                        BYTE     %01000010
                        BYTE     %01000010
                        BYTE     %01000010
                        BYTE     %01000010
                        BYTE     %01111110
                        BYTE     %00000000

        box3            BYTE     %00000000
                        BYTE     %00000000
                        BYTE     %00111100
                        BYTE     %00100100
                        BYTE     %00100100
                        BYTE     %00111100
                        BYTE     %00000000
                        BYTE     %00000000

        box4            BYTE     %00000000
                        BYTE     %00000000
                        BYTE     %00000000
                        BYTE     %00011000
                        BYTE     %00011000
                        BYTE     %00000000
                        BYTE     %00000000
                        BYTE     %00000000

        row             BYTE     %11111111
                        BYTE     %00000000
                        BYTE     %00000000
                        BYTE     %00000000
                        BYTE     %00000000
                        BYTE     %00000000
                        BYTE     %00000000
                        BYTE     %00000000

        col             BYTE     %10000000
                        BYTE     %10000000
                        BYTE     %10000000
                        BYTE     %10000000
                        BYTE     %10000000
                        BYTE     %10000000
                        BYTE     %10000000
                        BYTE     %10000000


